
Redmine - Defect #5058

reminder mails are not sent when delivery_method is :async_smtp

2010-03-12 02:33 - Go MAEDA

Status: Closed Start date: 2010-03-12

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Email notifications Estimated time: 0.00 hour

Target version: 1.4.0   

Resolution: Fixed Affected version: 0.9.3

Description

Reminder mails (rake redmine:send_reminders) are not sent when I set delivery_method in config/email.yml to :async_smtp.

version: Redmine 0.9.3.stable.3561

Related issues:

Related to Redmine - Defect #5293: too slow ticket update in new version Closed 2010-04-12

Related to Redmine - Patch #613: Asynchronous email delivery Closed 2008-02-06

Is duplicate of Redmine - Defect #4228: no notification on  issue creation by... Closed 2009-11-17

Associated revisions

Revision 9367 - 2012-04-06 20:57 - Jean-Philippe Lang

Fixed: reminder mails are not sent when delivery_method is :async_smtp (#5058).

History

#1 - 2010-03-12 16:37 - Jean-Philippe Lang

- Category set to Email notifications

#2 - 2010-03-12 16:54 - Jean-Philippe Lang

Confirmed. The reason is that the process doesn't wait for the thread to finish. Adding a simple sleep works but it's not an elegant fix:

Index: app/models/mailer.rb

===================================================================

--- app/models/mailer.rb    (revision 3560)

+++ app/models/mailer.rb    (working copy)

@@ -323,6 +323,7 @@

     issues_by_assignee.each do |assignee, issues|

       deliver_reminder(assignee, issues, days) unless assignee.nil?

     end

+    sleep(10)

   end

   private

 Maybe we'd better disable asynchronous sending when sending reminders.

#3 - 2010-03-15 09:49 - Go MAEDA

Thanks for investigation.

How about this fix? Waiting for all threads to finish.

Index: app/models/mailer.rb

===================================================================

--- app/models/mailer.rb        (revision 3561)

+++ app/models/mailer.rb        (working copy)

@@ -309,6 +309,7 @@

     issues_by_assignee.each do |assignee, issues|

       deliver_reminder(assignee, issues, days) unless assignee.nil?

     end

+    Thread.list.each {|t| t.join(10) unless t == Thread.current}

   end

   private
#4 - 2011-03-01 11:59 - Etienne Massip

- Target version set to Candidate for next minor release

#5 - 2011-03-01 14:02 - Etienne Massip

Go MAEDA wrote:

Thanks for investigation.

How about this fix? Waiting for all threads to finish.

[...]

 Note 19 of #4228 states that it does not work :(

#6 - 2011-03-12 15:34 - Etienne Massip

Would be nice if someone could test this change to lib/tasks/email.rake as proposed in #4228 :

task :receive_imap => :environment do

  Thread.abort_on_exception = true

  ...

  (existing code)

  ...

  threads.each {|t| t.join }

end

#7 - 2011-03-21 10:01 - Etienne Massip

- Status changed from New to Closed

Resolved by switching smtp delivery_method setting from async_smtp to smtp, which kind of a feature loss.

Would be great if someone could post a feedback of the change proposed in note-21.

#8 - 2011-03-21 10:03 - Etienne Massip

- Status changed from Closed to Reopened

Closed accidentally by closing duplicate.

#9 - 2011-06-27 20:06 - Anonymous

Etienne, it didnt work for me.

#10 - 2011-10-24 22:55 - Robert Hailey

I'm quite sure that this same issue has been causing emails to (sometimes) not be generated in response to email-stimulus (the

process-incoming-emails rake task). Drop rate <30%.

#11 - 2011-11-28 05:54 - Mischa The Evil

I just stumbled upon this issue and finally found out why I never got the reminder emails feature working...

Etienne Massip wrote:

Would be nice if someone could test this change to lib/tasks/email.rake as proposed in #4228 :

[...]

 Just tested it, but the same as Serge ST, it isn't working.

Note: I've added a reference to this issue on RedmineReminderEmails and EmailConfiguration.

#12 - 2012-04-06 20:57 - Jean-Philippe Lang

- Status changed from Reopened to Resolved

- Target version changed from Candidate for next minor release to 1.4.0

- Resolution set to Fixed

This should be fixed in r9367.
https://www.redmine.org/issues/4228
https://www.redmine.org/issues/4228
https://www.redmine.org/issues/4228
https://www.redmine.org/projects/redmine/wiki/RedmineReminderEmails
https://www.redmine.org/projects/redmine/wiki/EmailConfiguration
https://www.redmine.org/projects/redmine/repository/svn/revisions/9367


#13 - 2012-04-09 08:25 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged in r9375.
